/* $Id: TableHandling.js,v 1.31.2.2 2005/07/01 06:35:51 kps Exp $ */
String.prototype.trim = function() {
  var x=this;
  x=x.replace(/^\s*(.*)/, "$1");
  x=x.replace(/(.*?)\s*$/, "$1");
  return x;
}
function sortData(id, columnName){
	var uniqueId = getUniqueId(id);
	updateState(uniqueId, "_SB", columnName);
	updateState(uniqueId, "_FI", "1");
	updateState(uniqueId, "_TI", null);
	updateState(uniqueId, "_PN", null);
	var order = stateData[uniqueId]["_SO"];
	if(order == "D"){
		updateState(uniqueId, "_SO","A");
	}
	else{
		updateState(uniqueId, "_SO","D");
	}
        stateData[uniqueId]["_VMD"]= '1';
	refreshSubView(uniqueId);
}

function showRange(id, fromIndex, pageNumber){
	var uniqueId = getUniqueId(id);
		updateState(uniqueId, "_FI", fromIndex);
		updateState(uniqueId, "_PN", pageNumber);
                stateData[uniqueId]["_VMD"]= '1';
		refreshSubView(uniqueId);
}

function showRangeForLength(id, pageLength){
	var uniqueId = getUniqueId(id);
		updateState(uniqueId, "_PL", pageLength);
		updateState(uniqueId, "_FI", "1");
		updateState(uniqueId, "_PN", null);
                stateData[uniqueId]["_VMD"]= '1';
		refreshSubView(uniqueId);
}

function enableField(formName){
		var element = document.getElementById(formName);
}


function updateFormValues(id, form){
	var uniqueId = getUniqueId(id);
  var length = form.elements.length;
	if(!validateForm(form)){
		return false;
	}
  var searchColumns = "";
  var searchValues = "";
  var initial = true;
	for(i = 0; i < length; i++){
		type = form.elements[i].type;
		if(type == "text"){
			name = form.elements[i].name;
			value = form.elements[i].value;
			if(value != null && value.trim() != ""){
				if(!initial){
					searchColumns = searchColumns + ",";
					searchValues = searchValues + ",";
				}
				searchColumns = searchColumns + name;
				searchValues = searchValues + value;
				initial = false;
			}
		}
	}

  updateState(uniqueId, "SEARCH_COLUMN", searchColumns);
  updateState(uniqueId, "SEARCH_VALUE", searchValues);
  updateState(uniqueId, "_SB", null);
  stateData[uniqueId]["_VMD"]= '1';
  updateState(uniqueId, "_FI", "1");
  updateState(uniqueId, "_TI", null);
  refreshSubView(uniqueId);
  return false;
}

function createRow(id, tableAlias, count, rowValues){
	var uniqueId = getUniqueId(id);
	var referenceId = getReferenceId(id);
	var vName = stateData[uniqueId]["_VN"];
	rowObject = new Object();
	var size = rowValues.length;
	for(i=0; i < size; i++){
		var colArr = eval("parent." + uniqueId + "_" + tableAlias + "_ColumnNames");
                if(colArr == null)
                {
                   return;
                }
		rowObject[colArr[i]] = rowValues[i];
	}  
	var table = eval("parent." + "T"+referenceId + "_" + tableAlias);
	table[count] = rowObject;
}

function alternateRows(id) {
	var even = false;
	var evenClass = arguments[1] ? arguments[1] : "#fff";
	var oddClass = arguments[2] ? arguments[2] : "#eee";
	var table = document.getElementById(id);
	if (! table) { return; }
	var tbodies = table.getElementsByTagName("tbody");
	for (var h = 0; h < tbodies.length; h++) {
		var trs = tbodies[h].getElementsByTagName("tr");
		for (var i = 0; i < trs.length; i++) {
			var tds = trs[i].getElementsByTagName("td");
			for (var j = 0; j < tds.length; j++) {
				var mytd = tds[j];
				mytd.setAttribute("class",even ? evenClass : oddClass);
			}
			even =  ! even;
		}
	}
}

function closeSearch(id, formObj, refId)
{
	document.getElementById(id).className = "hide";
	document.getElementById(refId+"_OS").className = "tableSearchButton";
	document.getElementById(refId+"_CS").className = "hide";
	var isValPresent = false;
	if(formObj.elements != null){
		var size = formObj.elements.length;
		for(var count = 0; count < size; count++){
			var element = formObj.elements[count];
			if(element.type == "text"){
				if(element.value != ""){
					element.value = "";
					isValPresent = true;
				}
			}
		}
	}		
	if(isValPresent){
		updateFormValues(getUniqueId(refId), formObj);
	}
}

function openSearch(id, formObj, refId){
	document.getElementById(id).className = "";
	document.getElementById(refId+"_OS").className = "hide";
	document.getElementById(refId+"_CS").className = "tableSearchCloseButton";

	if(formObj.elements != null){
		var size = formObj.elements.length;
		for(var count = 0; count < size; count++){
			var element = formObj.elements[count];
			if(element.type == "text"){
				element.focus();
				break;
			}
		}
	}
}

function updateSearchData(id, select){
	var uniqueId = getUniqueId(id);
  searchColumn = select.name;
  searchValue = select.value;
  updateState(uniqueId, "SEARCH_COLUMN", searchColumn);
  updateState(uniqueId, "SEARCH_VALUE", searchValue);
  updateState(uniqueId, "_SB", null);
  stateData[uniqueId]["_VMD"]= '1';
  updateState(uniqueId, "_FI", "1");
  updateState(uniqueId, "_TI", null);
  updateState(uniqueId, "_PN", null);
  stateData[uniqueId]["_VMD"]= '1';
  refreshSubView(uniqueId);
  return false;
}


function enableNavigators(){
	var element = null;
	if(pageNumber > 1){
		element = document.getElementById('PREV_LINK');
		element.className = 'show';
		element = document.getElementById("PREV_TEXT");
		element.className = 'hide';
	}
	else{
		element = document.getElementById('PREV_LINK');
		element.className = 'hide';
		element = document.getElementById("PREV_TEXT");
		element.className = 'show';

	}
	if(pageNumber < totalPages){
		element = document.getElementById('NEXT_LINK');
		element.className = 'show';
		element = document.getElementById("NEXT_TEXT");
		element.className = 'hide';
	}
	else{
		element = document.getElementById('NEXT_LINK');
		element.className = 'hide';
		element = document.getElementById("NEXT_TEXT");
		element.className = 'show';
	}
}


function showCompleteMessage(message, curId){
	showCustomMessage(message, document.getElementById(curId), 'completeMessage');
	/*
	var obj = document.getElementById("completeMsgDiv");
	document.getElementById('msgContent').innerHTML = message;
	obj.style.left = findPosX(getObj(curId));
	obj.style.top = findPosY(getObj(curId)) + 12;
	obj.style.width = document.getElementById(curId).parentNode.offsetWidth;
	obj.className = 'show';
	dragobject = obj;
	*/
}

function hideCompleteMessage(){
	document.getElementById("completeMsgDiv").className = "hide";
}
